#include "LOLDraw.h"
#include "math.h"
#include "Charliplexing.h"


void LOLDraw::Point(uint8_t x, uint8_t y)
{
	if(x>=0 && x<=13 && y>=0 && y<=8)
	    LedSign::Set(x,y,1);
}
	



void LOLDraw::Line( int x1, int y1, int x2, int y2)
{
	int dx, dy, sx, sy, err, e2;
	dx = fabs(x2-x1);
	dy = fabs(y2-y1);
	if (x1<x2)
		sx = 1;
	else
		sx = -1;
	
	
	if (y1<y2)
		sy = 1;
	else
		sy = -1;
	
	err = dx-dy;
	
	do
	{
		LOLDraw::Point(x1, y1);
		if ((x1 == x2) && (y1 == y2))
			break;
		e2 = 2*err;
		if (e2 > -dy)
		{
			err = err - dy;
			x1 = x1+sx;
		}
		if (e2 < dx)
		{
			err = err + dx;
			y1 = y1 + sy;
		}
	}
	while (1);
	
}


void LOLDraw::Triangle (uint8_t x1, uint8_t y1, uint8_t x2, uint8_t y2, uint8_t x3, uint8_t y3)
{
    LOLDraw::Line (x1, y1, x2, y2);
	LOLDraw::Line (x2, y2, x3, y3);
	LOLDraw::Line (x3, y3, x1, x1);

}


void LOLDraw::Rectangle( uint8_t x1, uint8_t y1, uint8_t x2, uint8_t y2)
{
    LOLDraw::Line(x1, y1, x1, y2);
	LOLDraw::Line(x1, y1, x2, y1);
	LOLDraw::Line(x2, y1, x2, y2);
	LOLDraw::Line(x1, y2, x2, y2);

}

void LOLDraw::Draw_4_Ellipse_Points(uint8_t CX, uint8_t CY, uint8_t X, uint8_t Y)
{
	LOLDraw::Point(CX+X, CY+Y);
	LOLDraw::Point(CX-X, CY+Y);
	LOLDraw::Point(CX-X, CY-Y);
	LOLDraw::Point(CX+X, CY-Y);

}


void LOLDraw::Ellipse(uint8_t CX, uint8_t CY, uint8_t XRadius, uint8_t YRadius)
{
	
	int X, Y, XChange, YChange, EllipseError, TwoASquare, TwoBSquare, StoppingX, StoppingY;
	TwoASquare = 2 * XRadius*XRadius;
	TwoBSquare = 2 * YRadius*YRadius;
	X = XRadius;
	Y = 0;
	XChange = YRadius*YRadius * (1-2*XRadius);
	YChange = XRadius*XRadius;
	EllipseError = 0;
	StoppingX = TwoBSquare*XRadius;
	StoppingY = 0;

	while (StoppingX >= StoppingY)	// 1st set of points, y'> -1
	{
		LOLDraw::Draw_4_Ellipse_Points (CX, CY, X, Y);
		Y++;
		StoppingY = StoppingY + TwoASquare;
		EllipseError = EllipseError + YChange;
		YChange = YChange + TwoASquare;
		if ((2*EllipseError + XChange) > 0)
		{
			X--;
			StoppingX = StoppingX - TwoBSquare;
			EllipseError = EllipseError + XChange;
			XChange = XChange + TwoBSquare;
		}
	}

	// 1st point set is done; start the 2nd set of points

	X = 0;
	Y = YRadius;
	XChange = YRadius*YRadius;
	YChange = XRadius*XRadius * (1-2*YRadius);
	EllipseError = 0;
	StoppingX = 0;
	StoppingY = TwoASquare * YRadius;

	while (StoppingX <= StoppingY)	// 2nd set of points, y'< -1
	{
		LOLDraw::Draw_4_Ellipse_Points (CX, CY, X, Y);
		X++;
		StoppingX = StoppingX + TwoBSquare;
		EllipseError = EllipseError + XChange;
		XChange = XChange + TwoBSquare;
		if ((2*EllipseError + YChange) > 0)
		{
			Y--;
			StoppingY = StoppingY - TwoASquare;
			EllipseError = EllipseError + YChange;
			YChange = YChange + TwoASquare;
		}	
	}
}

void LOLDraw::Circle(uint8_t x, uint8_t y, uint8_t r)
{
	LOLDraw::Ellipse(x, y, r, r);

}



